#!/bin/sh

# major architectures.
targets="arm-elf h8300-elf i386-elf mips-elf powerpc-elf sh-elf"

# other architectures.
targets="$targets arc-elf avr-elf cris-elf fr30-elf frv-elf hppa-linux"
targets="$targets m32r-elf m6811-elf m68k-elf mcore-elf mips64-elf mmix-elf"
targets="$targets mn10300-elf pdp11-aout powerpc64-linux s390-linux sh64-elf"
targets="$targets sparc-elf strongarm-elf v850-elf x86_64-linux xscale-elf"
targets="$targets xstormy16-elf xtensa-elf"

# need patches to build cross binutils/gcc.
targets="$targets alpha-elf ia64-elf vax-netbsdelf"

# need obsolete option to build cross gcc.
targets="$targets i960-elf"

# succeeded, but failed to build gcc.
##targets="$targets alpha-linux alpha-vms bfin-elf hppa-elf"
##targets="$targets i370-elf i370-linux i960-elf iq2000-elf"
##targets="$targets m32c-elf microblaze-elf msp430-elf pdp11-dec-bsd"
##targets="$targets rs6000-aix x86_64-elf x86_64-w64-mingw32 z80-coff z8k-coff"
##targets="$targets vax-linux"

# binutils cross build failed.
##targets="$targets alpha-dec-osf alpha-elf i370-ibm-opened"
##targets="$targets i960-coff i960-intel i960-unknown-coff"
##targets="$targets m88k-coff m88k-elf nios2-elf pdp11-elf rs6000-elf"
##targets="$targets s390-elf thumb-elf tron-elf v810-elf vax-elf vax-vms"
##targets="$targets z80-elf z8k-elf"

install_dir="/usr/local/cross"
binutils="binutils-2.21.1"

# default definition
make=make

# for FreeBSD
#make=gmake

opt="--prefix=$install_dir --disable-nls"

for target in $targets; do
    mkdir -p $target
    cd $target
    ../../../gnu/$binutils/configure --target=$target $opt
    $make
    cd ..
done
